;****************************************************************************************
;     Proteus  .    . .
;****************************************************************************************

             list      p=16f630   ; 
             #include  p16f630.inc  ;   . 
             __config  3f94h         ; MCLRE  .
                                     ; WDT  .
                                     ; PWRT .
                                     ;  RC- 4
                                     ; CP -    .
                                     ; CPD-   EEPROM .
                                     ; BOREN -     
;****************************************************************************************
;  
;****************************************************************************************
        
w_temp       equ       20h
stat_temp    equ       21h
temp         equ       23h
temp1        equ       24h

flags        equ       30h           ;  .

RA0          equ       0             
RA1          equ       1
RA2          equ       2          
;****************************
;   . 
;****************************                                   
             org        0
             goto      start
;****************************
;    .
;****************************
             org        4
;****************************
;  
;****************************
;    STATUS  W  .
;----------------------------------------------------
int          movwf     w_temp        ; W -> w_temp 
             movf      STATUS,W      ; STATUS -> W
             movwf     stat_temp     ; W -> stat_temp
             bcf       STATUS,RP0    ;  0   . 
;---------------------------------------------------------------------
;      RB0,    .
;---------------------------------------------------------------------
RAx          movf      PORTA,F       ;     
 
             btfss     flags,RA2
             goto      on_RA2        ; 
             goto      off_RA2       ;             
on_RA2       bsf       PORTC,0       ;  "1".
             bsf       flags,RA2
             goto      end_int                                           
off_RA2      bcf       PORTC,0       ;  "0".
             bcf       flags,RA2     
             goto      end_int       
;-------------------------------------------------------------------
;          .
;-------------------------------------------------------------------
end_int
timer_Xms
             movlw      .100
             movwf      temp1
loop         movlw      .10
             movwf      temp
             decfsz     temp,F
             goto       $-1
             decfsz     temp1,F
             goto       loop 

             bcf       INTCON,RAIF   ;  .     Rx.                 
             movf      stat_temp,W   ; 
             movwf     STATUS        ; 
             swapf     w_temp,F
             swapf     w_temp,W
             retfie                  ;   
;*****************************************************************************************

;---------------------------------------------------------------------------------------------
;  .
;---------------------------------------------------------------------------------------------
start        movlw     .7
             movwf     CMCON
;*********************************************************************************************
; 
;*********************************************************************************************
             clrf      INTCON
             clrf      PORTA         ;     .
             clrf      PORTC         ;     .
             bsf       STATUS,RP0    ; 1- . 
             call       3FFH           ;   
             movwf      OSCCAL         ;      OSCCAL. 
             movlw     b'11111111'   
             movwf     TRISA         ;   .
             movlw     b'11111110'   
             movwf     TRISC        
             movlw     b'10000111'   ; 
             movwf     OPTION_REG    ;  .TMR0=256,    CLKOUT
                                     ;    (7-  =1)
             bsf       IOCA,2        ;      
                                     ;     RA2. 
             bcf       STATUS,RP0  
             bsf       INTCON,GIE    ;   .

             bsf       INTCON,PEIE   ;     .
;*********************
;**  Rx     ***
;***********************             

             bsf       INTCON,RAIE   ;     .   
                                     ;   Rx (     .IOCAx).
             nop
             goto      $-1

;*********************************************************************************************
             end                             
;DataSectionPreferencesPicAsmEditor
;CursorPosition = 3168
;Folding = 
;PIC = PIC16F628A